'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var getDependencies = function getDependencies(components, type) {
  return function (attrs) {
    var toResolve = components.filter(function (component) {
      return component && component.asyncResolve && component.asyncResolve[type];
    }).map(function (component) {
      return component.asyncResolve[type];
    });
    return [].concat.apply([], toResolve).filter(function (resolve) {
      return resolve;
    }) // only to support asyncResolve, will be removed in future
    .map(function (resolve) {
      return resolve(attrs);
    });
  };
};

var getPreResolveDependencies = exports.getPreResolveDependencies = function getPreResolveDependencies(components) {
  return getDependencies(components, 'preResolve');
};
var getDeferResolveDependencies = exports.getDeferResolveDependencies = function getDeferResolveDependencies(components) {
  return getDependencies(components, 'deferResolve');
};